diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/simulator.h ns-3.31/src/core/model/simulator.h
--- ns-3.30.1/src/core/model/simulator.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/simulator.h	2020-06-27 17:38:30.000000000 -0700
@@ -1384,406 +549,70 @@
 // Doxygen has trouble with static template functions in a class:
 // it treats the in-class declaration as different from the
 // out of class definition, so makes two entries in the member list.  Ugh
-  
-template <typename MEM, typename OBJ>
-EventId Simulator::Schedule (Time const &delay, MEM mem_ptr, OBJ obj) 
-{
-  return DoSchedule (delay, MakeEvent (mem_ptr, obj));
-}
-
-
-template <typename MEM, typename OBJ,
-          typename T1>
-EventId Simulator::Schedule (Time const &delay, MEM mem_ptr, OBJ obj, T1 a1) 
-{
-  return DoSchedule (delay, MakeEvent (mem_ptr, obj, a1));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2>
-EventId Simulator::Schedule (Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2)
-{
-  return DoSchedule (delay, MakeEvent (mem_ptr, obj, a1, a2));
-}
-
-template <typename MEM, typename OBJ,
-          typename T1, typename T2, typename T3>
-EventId Simulator::Schedule (Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3) 
-{
-  return DoSchedule (delay, MakeEvent (mem_ptr, obj, a1, a2, a3));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3, typename T4>
-EventId Simulator::Schedule (Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3, T4 a4) 
-{
-  return DoSchedule (delay, MakeEvent (mem_ptr, obj, a1, a2, a3, a4));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3, typename T4, typename T5>
-EventId Simulator::Schedule (Time const &delay, MEM mem_ptr, OBJ obj, 
-                             T1 a1, T2 a2, T3 a3, T4 a4, T5 a5) 
-{
-  return DoSchedule (delay, MakeEvent (mem_ptr, obj, a1, a2, a3, a4, a5));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-EventId Simulator::Schedule (Time const &time, MEM mem_ptr, OBJ obj, 
-                             T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6) 
-{
-  return DoSchedule (time, MakeEvent (mem_ptr, obj, a1, a2, a3, a4, a5, a6));
-}
-
-template <typename U1,
-          typename T1>
-EventId Simulator::Schedule (Time const &delay, void (*f)(U1), T1 a1)
-{
-  return DoSchedule (delay, MakeEvent (f, a1));
-}
-
-template <typename U1, typename U2, 
-          typename T1, typename T2>
-EventId Simulator::Schedule (Time const &delay, void (*f)(U1,U2), T1 a1, T2 a2)
-{
-  return DoSchedule (delay, MakeEvent (f, a1, a2));
-}
-
-template <typename U1, typename U2, typename U3,
-          typename T1, typename T2, typename T3>
-EventId Simulator::Schedule (Time const &delay, void (*f)(U1,U2,U3), T1 a1, T2 a2, T3 a3)
-{
-  return DoSchedule (delay, MakeEvent (f, a1, a2, a3));
-}
-
-template <typename U1, typename U2, typename U3, typename U4,
-          typename T1, typename T2, typename T3, typename T4>
-EventId Simulator::Schedule (Time const &delay, void (*f)(U1,U2,U3,U4), T1 a1, T2 a2, T3 a3, T4 a4)
-{
-  return DoSchedule (delay, MakeEvent (f, a1, a2, a3, a4));
-}
-
-template <typename U1, typename U2, typename U3, typename U4, typename U5,
-          typename T1, typename T2, typename T3, typename T4, typename T5>
-EventId Simulator::Schedule (Time const &delay, void (*f)(U1,U2,U3,U4,U5), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
-{
-  return DoSchedule (delay, MakeEvent (f, a1, a2, a3, a4, a5));
-}
-
-template <typename U1, typename U2, typename U3, typename U4, typename U5, typename U6,
-          typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-EventId Simulator::Schedule (Time const &time, void (*f)(U1,U2,U3,U4,U5,U6), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
-{
-  return DoSchedule (time, MakeEvent (f, a1, a2, a3, a4, a5, a6));
-}
-
-
-template <typename MEM, typename OBJ>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj)
-{
-  ScheduleWithContext (context, delay, MakeEvent (mem_ptr, obj));
-}
-
-
-template <typename MEM, typename OBJ,
-          typename T1>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, T1 a1)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (mem_ptr, obj, a1));
-}
-
-template <typename MEM, typename OBJ,
-          typename T1, typename T2>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (mem_ptr, obj, a1, a2));
-}
-
-template <typename MEM, typename OBJ,
-          typename T1, typename T2, typename T3>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (mem_ptr, obj, a1, a2, a3));
-}
-
-template <typename MEM, typename OBJ,
-          typename T1, typename T2, typename T3, typename T4>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3, T4 a4)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (mem_ptr, obj, a1, a2, a3, a4));
-}
-
-template <typename MEM, typename OBJ,
-          typename T1, typename T2, typename T3, typename T4, typename T5>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj,
-                                     T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (mem_ptr, obj, a1, a2, a3, a4, a5));
-}
-
-template <typename MEM, typename OBJ,
-          typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &time, MEM mem_ptr, OBJ obj,
-                                     T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
-{
-  return ScheduleWithContext (context, time, MakeEvent (mem_ptr, obj, a1, a2, a3, a4, a5, a6));
-}
-
-template <typename U1,
-          typename T1>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1), T1 a1)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (f, a1));
-}
-
-template <typename U1, typename U2,
-          typename T1, typename T2>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1,U2), T1 a1, T2 a2)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (f, a1, a2));
-}
-
-template <typename U1, typename U2, typename U3,
-          typename T1, typename T2, typename T3>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1,U2,U3), T1 a1, T2 a2, T3 a3)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (f, a1, a2, a3));
-}
-
-template <typename U1, typename U2, typename U3, typename U4,
-          typename T1, typename T2, typename T3, typename T4>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1,U2,U3,U4), T1 a1, T2 a2, T3 a3, T4 a4)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (f, a1, a2, a3, a4));
-}
-
-template <typename U1, typename U2, typename U3, typename U4, typename U5,
-          typename T1, typename T2, typename T3, typename T4, typename T5>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1,U2,U3,U4,U5), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
-{
-  return ScheduleWithContext (context, delay, MakeEvent (f, a1, a2, a3, a4, a5));
-}
-
-template <typename U1, typename U2, typename U3, typename U4, typename U5, typename U6,
-          typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-void Simulator::ScheduleWithContext (uint32_t context, Time const &time, void (*f)(U1,U2,U3,U4,U5,U6), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
-{
-  return ScheduleWithContext (context, time, MakeEvent (f, a1, a2, a3, a4, a5, a6));
-}
-
-
-template <typename MEM, typename OBJ>
-EventId
-Simulator::ScheduleNow (MEM mem_ptr, OBJ obj) 
-{
-  return DoScheduleNow (MakeEvent (mem_ptr, obj));
-}
-
-
-template <typename MEM, typename OBJ, 
-          typename T1>
-EventId
-Simulator::ScheduleNow (MEM mem_ptr, OBJ obj, T1 a1) 
-{
-  return DoScheduleNow (MakeEvent (mem_ptr, obj, a1));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2>
-EventId
-Simulator::ScheduleNow (MEM mem_ptr, OBJ obj, T1 a1, T2 a2) 
-{
-  return DoScheduleNow (MakeEvent (mem_ptr, obj, a1, a2));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3>
-EventId
-Simulator::ScheduleNow (MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3) 
-{
-  return DoScheduleNow (MakeEvent (mem_ptr, obj, a1, a2, a3));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3, typename T4>
-EventId
-Simulator::ScheduleNow (MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3, T4 a4) 
-{
-  return DoScheduleNow (MakeEvent (mem_ptr, obj, a1, a2, a3, a4));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3, typename T4, typename T5>
-EventId
-Simulator::ScheduleNow (MEM mem_ptr, OBJ obj, 
-                        T1 a1, T2 a2, T3 a3, T4 a4, T5 a5) 
-{
-  return DoScheduleNow (MakeEvent (mem_ptr, obj, a1, a2, a3, a4, a5));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-EventId
-Simulator::ScheduleNow (MEM mem_ptr, OBJ obj, 
-                        T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6) 
-{
-  return DoScheduleNow (MakeEvent (mem_ptr, obj, a1, a2, a3, a4, a5, a6));
-}
-
-template <typename U1,
-          typename T1>
-EventId
-Simulator::ScheduleNow (void (*f)(U1), T1 a1)
-{
-  return DoScheduleNow (MakeEvent (f, a1));
-}
-
-template <typename U1, typename U2,
-          typename T1, typename T2>
-EventId
-Simulator::ScheduleNow (void (*f)(U1,U2), T1 a1, T2 a2)
-{
-  return DoScheduleNow (MakeEvent (f, a1, a2));
-}
-
-template <typename U1, typename U2, typename U3,
-          typename T1, typename T2, typename T3>
-EventId
-Simulator::ScheduleNow (void (*f)(U1,U2,U3), T1 a1, T2 a2, T3 a3)
-{
-  return DoScheduleNow (MakeEvent (f, a1, a2, a3));
-}
-
-template <typename U1, typename U2, typename U3, typename U4,
-          typename T1, typename T2, typename T3, typename T4>
-EventId
-Simulator::ScheduleNow (void (*f)(U1,U2,U3,U4), T1 a1, T2 a2, T3 a3, T4 a4)
-{
-  return DoScheduleNow (MakeEvent (f, a1, a2, a3, a4));
-}
-
-template <typename U1, typename U2, typename U3, typename U4, typename U5,
-          typename T1, typename T2, typename T3, typename T4, typename T5>
-EventId
-Simulator::ScheduleNow (void (*f)(U1,U2,U3,U4,U5), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
-{
-  return DoScheduleNow (MakeEvent (f, a1, a2, a3, a4, a5));
-}
 
-template <typename U1, typename U2, typename U3, typename U4, typename U5, typename U6,
-          typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-EventId
-Simulator::ScheduleNow (void (*f)(U1,U2,U3,U4,U5,U6), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
+template <typename FUNC,
+          typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value,int>::type,
+          typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,int>::type,
+          typename... Ts>
+EventId Simulator::Schedule (Time const &delay, FUNC f, Ts&&... args)
 {
-  return DoScheduleNow (MakeEvent (f, a1, a2, a3, a4, a5, a6));
+  return DoSchedule (delay, MakeEvent (f, std::forward<Ts> (args)...));
 }
 
-
-template <typename MEM, typename OBJ>
-EventId
-Simulator::ScheduleDestroy (MEM mem_ptr, OBJ obj) 
+template <typename... Us, typename... Ts>
+EventId Simulator::Schedule (Time const &delay, void (*f)(Us...), Ts&&... args)
 {
-  return DoScheduleDestroy (MakeEvent (mem_ptr, obj));
+  return DoSchedule (delay, MakeEvent (f, std::forward<Ts> (args)...));
 }
 
-
-template <typename MEM, typename OBJ, 
-          typename T1>
-EventId
-Simulator::ScheduleDestroy (MEM mem_ptr, OBJ obj, T1 a1) 
+template <typename FUNC,
+          typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value,int>::type,
+          typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,int>::type,
+          typename... Ts>
+void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, FUNC f, Ts&&... args)
 {
-  return DoScheduleDestroy (MakeEvent (mem_ptr, obj, a1));
+  return ScheduleWithContext (context, delay, MakeEvent (f, std::forward<Ts> (args)...));
 }
 
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2>
-EventId
-Simulator::ScheduleDestroy (MEM mem_ptr, OBJ obj, T1 a1, T2 a2) 
+template <typename... Us, typename... Ts>
+void Simulator::ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(Us...), Ts&&... args)
 {
-  return DoScheduleDestroy (MakeEvent (mem_ptr, obj, a1, a2));
+  return ScheduleWithContext (context, delay, MakeEvent (f, std::forward<Ts> (args)...));
 }
 
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3>
+template <typename FUNC,
+          typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value,int>::type,
+          typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,int>::type,
+          typename... Ts>
 EventId
-Simulator::ScheduleDestroy (MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3) 
+Simulator::ScheduleNow (FUNC f, Ts&&... args)
 {
-  return DoScheduleDestroy (MakeEvent (mem_ptr, obj, a1, a2, a3));
+  return DoScheduleNow (MakeEvent (f, std::forward<Ts> (args)...));
 }
 
-template <typename MEM, typename OBJ,
-          typename T1, typename T2, typename T3, typename T4>
+template <typename... Us, typename... Ts>
 EventId
-Simulator::ScheduleDestroy (MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3, T4 a4) 
+Simulator::ScheduleNow (void (*f)(Us...), Ts&&... args)
 {
-  return DoScheduleDestroy (MakeEvent (mem_ptr, obj, a1, a2, a3, a4));
+  return DoScheduleNow (MakeEvent (f, std::forward<Ts> (args)...));
 }
 
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3, typename T4, typename T5>
-EventId
-Simulator::ScheduleDestroy (MEM mem_ptr, OBJ obj, 
-                            T1 a1, T2 a2, T3 a3, T4 a4, T5 a5) 
-{
-  return DoScheduleDestroy (MakeEvent (mem_ptr, obj, a1, a2, a3, a4, a5));
-}
-
-template <typename MEM, typename OBJ, 
-          typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-EventId
-Simulator::ScheduleDestroy (MEM mem_ptr, OBJ obj, 
-                            T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6) 
-{
-  return DoScheduleDestroy (MakeEvent (mem_ptr, obj, a1, a2, a3, a4, a5, a6));
-}
-
-template <typename U1,
-          typename T1>
-EventId
-Simulator::ScheduleDestroy (void (*f)(U1), T1 a1)
-{
-  return DoScheduleDestroy (MakeEvent (f, a1));
-}
-
-template <typename U1, typename U2,
-          typename T1, typename T2>
-EventId
-Simulator::ScheduleDestroy (void (*f)(U1,U2), T1 a1, T2 a2)
-{
-  return DoScheduleDestroy (MakeEvent (f, a1, a2));
-}
-
-template <typename U1, typename U2, typename U3,
-          typename T1, typename T2, typename T3>
-EventId
-Simulator::ScheduleDestroy (void (*f)(U1,U2,U3), T1 a1, T2 a2, T3 a3)
-{
-  return DoScheduleDestroy (MakeEvent (f, a1, a2, a3));
-}
-
-template <typename U1, typename U2, typename U3, typename U4,
-          typename T1, typename T2, typename T3, typename T4>
-EventId
-Simulator::ScheduleDestroy (void (*f)(U1,U2,U3,U4), T1 a1, T2 a2, T3 a3, T4 a4)
-{
-  return DoScheduleDestroy (MakeEvent (f, a1, a2, a3, a4));
-}
 
-template <typename U1, typename U2, typename U3, typename U4, typename U5,
-          typename T1, typename T2, typename T3, typename T4, typename T5>
+template <typename FUNC,
+          typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value,int>::type,
+          typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,int>::type,
+          typename... Ts>
 EventId
-Simulator::ScheduleDestroy (void (*f)(U1,U2,U3,U4,U5), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
+Simulator::ScheduleDestroy (FUNC f, Ts&&... args)
 {
-  return DoScheduleDestroy (MakeEvent (f, a1, a2, a3, a4, a5));
+  return DoScheduleDestroy (MakeEvent (f, std::forward<Ts> (args)...));
 }
 
-template <typename U1, typename U2, typename U3, typename U4, typename U5, typename U6,
-          typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
+template <typename... Us, typename... Ts>
 EventId
-Simulator::ScheduleDestroy (void (*f)(U1,U2,U3,U4,U5,U6), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
+Simulator::ScheduleDestroy (void (*f)(Us...), Ts&&... args)
 {
-  return DoScheduleDestroy (MakeEvent (f, a1, a2, a3, a4, a5, a6));
+  return DoScheduleDestroy (MakeEvent (f, std::forward<Ts> (args)...));
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/synchronizer.cc ns-3.31/src/core/model/synchronizer.cc
--- ns-3.30.1/src/core/model/synchronizer.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/synchronizer.cc	2020-06-27 17:38:30.000000000 -0700
@@ -31,7 +31,7 @@
 
 NS_OBJECT_ENSURE_REGISTERED (Synchronizer);
 
-TypeId 
+TypeId
 Synchronizer::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::Synchronizer")
@@ -88,10 +88,12 @@
   NS_LOG_FUNCTION (this << ts);
   int64_t tDrift = DoGetDrift (TimeStepToNanosecond (ts));
 
-  if (tDrift < 0) 
+  if (tDrift < 0)
     {
       return -static_cast<int64_t> (NanosecondToTimeStep (-tDrift));
-    } else {
+    }
+  else
+    {
       return static_cast<int64_t> (NanosecondToTimeStep (tDrift));
     }
 }
@@ -100,7 +102,7 @@
 Synchronizer::Synchronize (uint64_t tsCurrent, uint64_t tsDelay)
 {
   NS_LOG_FUNCTION (this << tsCurrent << tsDelay);
-  return DoSynchronize (TimeStepToNanosecond (tsCurrent), 
+  return DoSynchronize (TimeStepToNanosecond (tsCurrent),
                         TimeStepToNanosecond (tsDelay));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/system-path.cc ns-3.31/src/core/model/system-path.cc
--- ns-3.30.1/src/core/model/system-path.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/system-path.cc	2020-06-27 17:38:30.000000000 -0700
@@ -22,10 +22,12 @@
 #include "assert.h"
 #include "log.h"
 #include "ns3/core-config.h"
-#include <cstdlib>
-#include <cerrno>
-#include <cstring>
 
+#include <algorithm>
+#include <cstdlib>  // getenv
+#include <cerrno>
+#include <cstring>  // strlen
+#include <tuple>
 
 #if defined (HAVE_DIRENT_H) && defined (HAVE_SYS_TYPES_H)
 /** Do we have an \c opendir function? */
@@ -73,6 +75,57 @@
 
 NS_LOG_COMPONENT_DEFINE ("SystemPath");
 
+// unnamed namespace for internal linkage
+namespace {
+/**
+ * \ingroup systempath
+ * Get the list of files located in a file system directory with error.
+ *
+ * \param [in] path A path which identifies a directory
+ * \return Tuple with a list of the filenames which are located in the input directory or error flag \c true if directory doesn't exist.
+ */
+std::tuple<std::list<std::string>, bool> ReadFilesNoThrow (std::string path)
+{
+  NS_LOG_FUNCTION (path);
+  std::list<std::string> files;
+
+#if defined HAVE_OPENDIR
+  DIR *dp = opendir (path.c_str ());
+  if (dp == NULL)
+    {
+      return std::make_tuple (files, true);
+    }
+  struct dirent *de = readdir (dp);
+  while (de != 0)
+    {
+      files.push_back (de->d_name);
+      de = readdir (dp);
+    }
+  closedir (dp);
+#elif defined (HAVE_FIND_FIRST_FILE)
+  /** \todo untested */
+  HANDLE hFind;
+  WIN32_FIND_DATA fileData;
+
+  hFind = FindFirstFile (path.c_str (), &FindFileData);
+  if (hFind == INVALID_HANDLE_VALUE)
+    {
+      return std::make_tuple (files, true);
+    }
+  do
+    {
+      files.push_back (fileData.cFileName);
+    }
+  while (FindNextFile (hFind, &fileData));
+  FindClose (hFind);
+#else
+#error "No support for reading a directory on this platform"
+#endif
+  return std::make_tuple (files, false);
+}
+
+} // unnamed namespace
+
 namespace SystemPath {
 
 /**
@@ -81,7 +134,7 @@
  *
  * This is an internal function (by virtue of not being
  * declared in a \c .h file); the public API is FindSelfDirectory().
- * 
+ *
  * \param [in] path The full path to a file.
  * \returns The full path to the containing directory.
  */
@@ -89,14 +142,14 @@
 {
   NS_LOG_FUNCTION (path);
   std::list<std::string> elements = Split (path);
-  std::list<std::string>::const_iterator last = elements.end();
+  std::list<std::string>::const_iterator last = elements.end ();
   last--;
   return Join (elements.begin (), last);
 }
 
 std::string FindSelfDirectory (void)
 {
-  /** 
+  /**
    * This function returns the path to the running $PREFIX.
    * Mac OS X: _NSGetExecutablePath() (man 3 dyld)
    * Linux: readlink /proc/self/exe
@@ -115,7 +168,7 @@
     int status;
     while (true)
       {
-        status = readlink("/proc/self/exe", buffer, size);
+        status = readlink ("/proc/self/exe", buffer, size);
         if (status != 1 || (status == -1 && errno != ENAMETOOLONG))
           {
             break;
@@ -123,7 +176,7 @@
         size *= 2;
         free (buffer);
         buffer = (char*)malloc (size);
-	memset (buffer, 0, size);
+        memset (buffer, 0, size);
       }
     if (status == -1)
       {
@@ -142,10 +195,10 @@
     DWORD status = GetModuleFilename (0, lpFilename, size);
     while (status == size)
       {
-	size = size * 2;
-	free (lpFilename);
-	lpFilename = (LPTSTR) malloc (sizeof(TCHAR) * size);
-	status = GetModuleFilename (0, lpFilename, size);
+        size = size * 2;
+        free (lpFilename);
+        lpFilename = (LPTSTR) malloc (sizeof(TCHAR) * size);
+        status = GetModuleFilename (0, lpFilename, size);
       }
     NS_ASSERT (status != 0);
     filename = lpFilename;
@@ -159,32 +212,32 @@
     int status = _NSGetExecutablePath (buffer, &bufsize);
     if (status == -1)
       {
-	free (buffer);
-	buffer = (char *) malloc (bufsize);
-	status = _NSGetExecutablePath (buffer, &bufsize);
+        free (buffer);
+        buffer = (char *) malloc (bufsize);
+        status = _NSGetExecutablePath (buffer, &bufsize);
       }
     NS_ASSERT (status == 0);
     filename = buffer;
     free (buffer);
-  } 
+  }
 #elif defined (__FreeBSD__)
   {
     int     mib[4];
     std::size_t  bufSize = 1024;
-    char   *buf = (char *) malloc(bufSize);
+    char   *buf = (char *) malloc (bufSize);
 
     mib[0] = CTL_KERN;
     mib[1] = KERN_PROC;
     mib[2] = KERN_PROC_PATHNAME;
     mib[3] = -1;
 
-    sysctl(mib, 4, buf, &bufSize, NULL, 0);
+    sysctl (mib, 4, buf, &bufSize, NULL, 0);
     filename = buf;
   }
 #endif
-    return Dirname (filename);
+  return Dirname (filename);
 }
-  
+
 std::string Append (std::string left, std::string right)
 {
   // removing trailing separators from 'left'
@@ -193,11 +246,11 @@
     {
       std::string::size_type lastSep = left.rfind (SYSTEM_PATH_SEP);
       if (lastSep != left.size () - 1)
-	{
-	  break;
-	}
+        {
+          break;
+        }
       left = left.substr (0, left.size () - 1);
-    } 
+    }
   std::string retval = left + SYSTEM_PATH_SEP + right;
   return retval;
 }
@@ -221,76 +274,56 @@
 }
 
 std::string Join (std::list<std::string>::const_iterator begin,
-		  std::list<std::string>::const_iterator end)
+                  std::list<std::string>::const_iterator end)
 {
-  NS_LOG_FUNCTION (&begin << &end);
+  NS_LOG_FUNCTION (*begin << *end);
   std::string retval = "";
   for (std::list<std::string>::const_iterator i = begin; i != end; i++)
     {
-      if (i == begin)
-	{
-	  retval = *i;
-	}
+      if (*i == "")
+        {
+          // skip empty strings in the path list
+          continue;
+        }
+      else if (i == begin)
+        {
+          retval = *i;
+        }
       else
-	{
-	  retval = retval + SYSTEM_PATH_SEP + *i;
-	}
+        {
+          retval = retval + SYSTEM_PATH_SEP + *i;
+        }
     }
   return retval;
 }
-  
+
 std::list<std::string> ReadFiles (std::string path)
 {
   NS_LOG_FUNCTION (path);
+  bool err;
   std::list<std::string> files;
-#if defined HAVE_OPENDIR
-  DIR *dp = opendir (path.c_str ());
-  if (dp == NULL)
-    {
-      NS_FATAL_ERROR ("Could not open directory=" << path);
-    }
-  struct dirent *de = readdir (dp);
-  while (de != 0)
-    {
-      files.push_back (de->d_name);
-      de = readdir (dp);
-    }
-  closedir (dp);
-#elif defined (HAVE_FIND_FIRST_FILE)
-  /** \todo untested */
-  HANDLE hFind;
-  WIN32_FIND_DATA fileData;
-  
-  hFind = FindFirstFile (path.c_str (), &FindFileData);
-  if (hFind == INVALID_HANDLE_VALUE)
+  std::tie (files, err) = ReadFilesNoThrow (path);
+  if (err)
     {
       NS_FATAL_ERROR ("Could not open directory=" << path);
     }
-  do
-    {
-      files.push_back (fileData.cFileName);
-    } while (FindNextFile (hFind, &fileData));
-  FindClose(hFind);
-#else
-#error "No support for reading a directory on this platform"
-#endif
   return files;
 }
 
-std::string 
+std::string
 MakeTemporaryDirectoryName (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
   char *path = NULL;
 
-  path = getenv ("TMP");
-  if (path == NULL)
+  path = std::getenv ("TMP");
+  if (path == NULL || std::strlen (path) == 0)
     {
-      path = getenv ("TEMP");
-      if (path == NULL)
-	{
-	  path = const_cast<char *> ("/tmp");
-	}
+      path = std::getenv ("TEMP");
+      if (path == NULL || std::strlen (path) == 0)
+        {
+          path = const_cast<char *> ("/tmp");
+        }
     }
 
   //
@@ -308,10 +341,10 @@
 
   //
   // The final path to the directory is going to look something like
-  // 
-  //   /tmp/ns3-14.30.29.32767
   //
-  // The first segment comes from one of the temporary directory env 
+  //   /tmp/ns3.14.30.29.32767
+  //
+  // The first segment comes from one of the temporary directory env
   // variables or /tmp if not found.  The directory name starts with an
   // identifier telling folks who is making all of the temp directories
   // and then the local time (in this case 14.30.29 -- which is 2:30 and
@@ -324,7 +357,7 @@
   return oss.str ();
 }
 
-void 
+void
 MakeDirectories (std::string path)
 {
   NS_LOG_FUNCTION (path);
@@ -344,7 +377,7 @@
       ++i;  // Now points to one past the directory we want to create
       std::string tmp = Join (elements.begin (), i);
       bool makeDirErr = false;
-      
+
 #if defined(HAVE_MKDIR_H)
       makeDirErr = mkdir (tmp.c_str (), S_IRWXU);
 #endif
@@ -356,6 +389,52 @@
     }
 }
 
+bool
+Exists (const std::string path)
+{
+  NS_LOG_FUNCTION (path);
+
+  bool err;
+  auto dirpath = Dirname (path);
+  std::list<std::string> files;
+  tie (files, err) = ReadFilesNoThrow (dirpath);
+  if (err)
+    {
+      // Directory doesn't exist
+      NS_LOG_LOGIC ("directory doesn't exist: " << dirpath);
+      return false;
+    }
+  NS_LOG_LOGIC ("directory exists: " << dirpath);
+
+  // Check if the file itself exists
+  auto tokens = Split (path);
+  std::string file = tokens.back ();
+
+  if (file == "")
+    {
+      // Last component was a directory, not a file name
+      // We already checked that the directory exists,
+      // so return true
+      NS_LOG_LOGIC ("directory path exists: " << path);
+      return true;
+    }
+
+  files = ReadFiles (dirpath);
+
+  auto it = std::find (files.begin (), files.end (), file);
+  if (it == files.end ())
+    {
+      // File itself doesn't exist
+      NS_LOG_LOGIC ("file itself doesn't exist: " << file);
+      return false;
+    }
+
+  NS_LOG_LOGIC ("file itself exists: " << file);
+  return true;
+
+}  // Exists()
+
+
 } // namespace SystemPath
 
 } // namespace ns3
